diff --git a/CRT.c b/CRT.c
index ca9a10d..1fefaff 100644
--- a/CRT.c
+++ b/CRT.c
@@ -128,6 +128,20 @@ typedef enum ColorElements_ {
    CPU_SOFTIRQ,
    CPU_STEAL,
    CPU_GUEST,
+   CPU_TEMP,
+   CPU_FREQ,
+   CPU_VCORE,
+   GPU_TEMP,
+   ETH0_INTERFACE,
+   ETH1_INTERFACE,
+   WLAN0_INTERFACE,
+   WLAN1_INTERFACE,    
+   KERNEL_VERSION,
+   DISTRO_VERSION,
+   OS_VERSION,
+   ARMBIAN_VERSION,
+   ETH0_STATS,
+   ETH1_STATS,
    LAST_COLORELEMENT
 } ColorElements;
 
@@ -232,6 +246,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = ColorPair(Magenta,Black),
       [CPU_STEAL] = ColorPair(Cyan,Black),
       [CPU_GUEST] = ColorPair(Cyan,Black),
+      [CPU_FREQ] = A_BOLD | ColorPair(Yellow,Black),
+      [CPU_TEMP] = A_BOLD | ColorPair(Red,Black),
+      [CPU_VCORE] = A_BOLD | ColorPair(Yellow,Black),
+      [GPU_TEMP] = ColorPair(Cyan,Black),
+      [ETH0_INTERFACE] = A_BOLD | ColorPair(Cyan,Black),
+      [ETH1_INTERFACE] = A_BOLD | ColorPair(Cyan,Black),
+      [WLAN0_INTERFACE] = A_BOLD | ColorPair(Cyan,Black),
+      [WLAN1_INTERFACE] = A_BOLD | ColorPair(Cyan,Black),
+      [KERNEL_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [DISTRO_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [OS_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [ARMBIAN_VERSION] = A_BOLD | ColorPair(Cyan,Black),
    },
    [COLORSCHEME_MONOCHROME] = {
       [RESET_COLOR] = A_NORMAL,
@@ -291,6 +317,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = A_BOLD,
       [CPU_STEAL] = A_REVERSE,
       [CPU_GUEST] = A_REVERSE,
+      [CPU_FREQ] = A_BOLD,
+      [CPU_TEMP] = A_BOLD,
+      [CPU_VCORE] = A_BOLD,
+      [GPU_TEMP] = A_BOLD,
+      [ETH0_INTERFACE] = A_BOLD,
+      [ETH1_INTERFACE] = A_BOLD,
+      [WLAN0_INTERFACE] = A_BOLD,
+      [WLAN1_INTERFACE] = A_BOLD,
+      [KERNEL_VERSION] = A_BOLD,
+      [DISTRO_VERSION] = A_BOLD,
+      [OS_VERSION] = A_BOLD,
+      [ARMBIAN_VERSION] = A_BOLD,      
    },
    [COLORSCHEME_BLACKONWHITE] = {
       [RESET_COLOR] = ColorPair(Black,White),
@@ -350,6 +388,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = ColorPair(Blue,White),
       [CPU_STEAL] = ColorPair(Cyan,White),
       [CPU_GUEST] = ColorPair(Cyan,White),
+      [CPU_FREQ] = A_BOLD | ColorPair(Yellow,White),
+      [CPU_TEMP] = A_BOLD | ColorPair(Yellow,White),
+      [CPU_VCORE] = A_BOLD | ColorPair(Yellow,White),
+      [GPU_TEMP] = A_BOLD | ColorPair(Yellow,White),
+      [ETH0_INTERFACE] = A_BOLD | ColorPair(Yellow,White),
+      [ETH1_INTERFACE] = A_BOLD | ColorPair(Yellow,White),
+      [WLAN0_INTERFACE] = A_BOLD | ColorPair(Yellow,White),
+      [WLAN1_INTERFACE] = A_BOLD | ColorPair(Yellow,White),
+      [KERNEL_VERSION] = A_BOLD | ColorPair(Yellow,White),
+      [DISTRO_VERSION] = A_BOLD | ColorPair(Yellow,White),
+      [OS_VERSION] = A_BOLD | ColorPair(Yellow,White),
+      [ARMBIAN_VERSION] = A_BOLD | ColorPair(Yellow,White),      
    },
    [COLORSCHEME_LIGHTTERMINAL] = {
       [RESET_COLOR] = ColorPair(Black,Black),
@@ -409,6 +459,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = ColorPair(Blue,Black),
       [CPU_STEAL] = ColorPair(Black,Black),
       [CPU_GUEST] = ColorPair(Black,Black),
+      [CPU_FREQ] = A_BOLD | ColorPair(Yellow,Black),
+      [CPU_TEMP] = A_BOLD | ColorPair(Yellow,Black),
+      [CPU_VCORE] = A_BOLD | ColorPair(Yellow,Black),
+      [GPU_TEMP] = A_BOLD | ColorPair(Yellow,Black),
+      [ETH0_INTERFACE] = A_BOLD | ColorPair(Yellow,Black),
+      [ETH1_INTERFACE] = A_BOLD | ColorPair(Yellow,Black),
+      [WLAN0_INTERFACE] = A_BOLD | ColorPair(Yellow,Black),
+      [WLAN1_INTERFACE] = A_BOLD | ColorPair(Yellow,Black),
+      [KERNEL_VERSION] = A_BOLD | ColorPair(Yellow,Black),
+      [DISTRO_VERSION] = A_BOLD | ColorPair(Yellow,Black),
+      [OS_VERSION] = A_BOLD | ColorPair(Yellow,Black),
+      [ARMBIAN_VERSION] = A_BOLD | ColorPair(Yellow,Black),      
    },
    [COLORSCHEME_MIDNIGHT] = {
       [RESET_COLOR] = ColorPair(White,Blue),
@@ -468,6 +530,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = ColorPair(Black,Blue),
       [CPU_STEAL] = ColorPair(White,Blue),
       [CPU_GUEST] = ColorPair(White,Blue),
+      [CPU_FREQ] = A_BOLD | ColorPair(Red,Black),
+      [CPU_TEMP] = A_BOLD | ColorPair(Red,Black),
+      [CPU_VCORE] = A_BOLD | ColorPair(Yellow,Black),
+      [GPU_TEMP] = A_BOLD | ColorPair(Yellow,Black),
+      [ETH0_INTERFACE] = A_BOLD | ColorPair(Cyan,Blue),
+      [ETH1_INTERFACE] = A_BOLD | ColorPair(Cyan,Blue),
+      [WLAN0_INTERFACE] = A_BOLD | ColorPair(Cyan,Blue),
+      [WLAN1_INTERFACE] = A_BOLD | ColorPair(Cyan,Blue),
+      [KERNEL_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [DISTRO_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [OS_VERSION] = A_BOLD | ColorPair(Cyan,Black),
+      [ARMBIAN_VERSION] = A_BOLD | ColorPair(Cyan,Black),      
    },
    [COLORSCHEME_BLACKNIGHT] = {
       [RESET_COLOR] = ColorPair(Cyan,Black),
@@ -527,6 +601,18 @@ int CRT_colorSchemes[LAST_COLORSCHEME][LAST_COLORELEMENT] = {
       [CPU_SOFTIRQ] = ColorPair(Blue,Black),
       [CPU_STEAL] = ColorPair(Cyan,Black),
       [CPU_GUEST] = ColorPair(Cyan,Black),
+      [CPU_FREQ] = A_BOLD | ColorPair(Red,Black),
+      [CPU_TEMP] = A_BOLD | ColorPair(Red,Black),
+      [CPU_VCORE] = A_BOLD | ColorPair(Yellow,Black),
+      [GPU_TEMP] = A_BOLD | ColorPair(Yellow,Black),
+      [ETH0_INTERFACE] = A_BOLD | ColorPair(Blue,Black),
+      [ETH1_INTERFACE] = A_BOLD | ColorPair(Blue,Black),
+      [WLAN0_INTERFACE] = A_BOLD | ColorPair(Blue,Black),
+      [WLAN1_INTERFACE] = A_BOLD | ColorPair(Blue,Black),
+      [KERNEL_VERSION] = A_BOLD | ColorPair(Blue,Black),
+      [DISTRO_VERSION] = A_BOLD | ColorPair(Blue,Black),
+      [OS_VERSION] = A_BOLD | ColorPair(Blue,Black),
+      [ARMBIAN_VERSION] = A_BOLD | ColorPair(Blue,Black),      
    },
    [COLORSCHEME_BROKENGRAY] = { 0 } // dynamically generated.
 };
@@ -596,6 +682,15 @@ void CRT_restorePrivileges() {
 // TODO: pass an instance of Settings instead.
 
 void CRT_init(int delay, int colorScheme) {
+#ifdef DEBUG    
+   setenv("TERM", "xterm", 1);
+   CRT_termType = getenv("TERM");
+   if (String_eq(CRT_termType, "linux"))
+      CRT_scrollHAmount = 20;
+   else
+      CRT_scrollHAmount = 5;
+   setenv("TERM", "xterm", 1);    
+#endif   
    initscr();
    noecho();
    CRT_delay = delay;
diff --git a/CRT.h b/CRT.h
index 933fe06..29ba16b 100644
--- a/CRT.h
+++ b/CRT.h
@@ -116,6 +116,20 @@ typedef enum ColorElements_ {
    CPU_SOFTIRQ,
    CPU_STEAL,
    CPU_GUEST,
+   CPU_TEMP,
+   CPU_FREQ,
+   CPU_VCORE,
+   GPU_TEMP,
+   ETH0_INTERFACE,
+   ETH1_INTERFACE,
+   WLAN0_INTERFACE,
+   WLAN1_INTERFACE,    
+   KERNEL_VERSION,
+   DISTRO_VERSION,
+   OS_VERSION,
+   ARMBIAN_VERSION,
+   ETH0_STATS,
+   ETH1_STATS,
    LAST_COLORELEMENT
 } ColorElements;
 
diff --git a/CpuFreqMeter.c b/CpuFreqMeter.c
new file mode 100644
index 0000000..6508180
--- /dev/null
+++ b/CpuFreqMeter.c
@@ -0,0 +1,109 @@
+/*
+htop - CpuFreqMeter.c
+(C) 2020 Alexander Finger
+*/
+
+#include "CpuFreqMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int CpuFreqMeter_attributes[] = {
+   CPU_FREQ
+};
+
+static void CpuFreqMeter_setValues(Meter* this, char* buffer, int len) {
+   int ghz,mhz,roundup;
+   int cpu, Freq;
+   int bigLITTLE;
+   char buf_b[32];
+   char buf_l[32];
+   int ln = sizeof(buf_l);
+   static int pulse = 0;
+
+   memset(buf_l, 0, sizeof(buf_l));
+   memset(buf_b, 0, sizeof(buf_b));
+   
+   bigLITTLE = Platform_getCpuBigLITTLE();
+   if (bigLITTLE)  {
+       cpu = bigLITTLE;
+       if (cpu < 0)
+           cpu = 0;
+       Freq = Platform_getCpuFreq(this, cpu);
+       if (Freq > 1000) {
+           Freq /= 1000;
+       }
+       if (Freq > 1000) {
+           ghz = Freq / 1000;
+           mhz = Freq % 1000;
+           roundup = ((mhz % 10) > 5);
+           mhz /= 10;
+           mhz += roundup;
+           xSnprintf(buf_b, ln, "%d.%02d GHz", ghz, mhz);
+       } else {
+           xSnprintf(buf_b, ln, "%4d MHz", Freq);
+       }
+       
+       cpu--;
+       if (cpu < 0)
+           cpu = 0;
+       Freq = Platform_getCpuFreq(this, cpu);
+       if (Freq > 1000) {
+           Freq /= 1000;
+       }
+       if (Freq > 1000) {
+           ghz = Freq / 1000;
+           mhz = Freq % 1000;
+           roundup = ((mhz % 10) > 5);
+           mhz /= 10;
+           mhz += roundup;
+           xSnprintf(buf_l, ln, "%d.%02d GHz", ghz, mhz);
+       } else {
+           xSnprintf(buf_l, ln, "%4d MHz", Freq);
+       }
+
+       if (pulse)
+          xSnprintf(buffer, len, "%s %s (big.LITTLE)", buf_b, buf_l, pulse);
+       else
+          xSnprintf(buffer, len, "%s %s             ", buf_b, buf_l, pulse);
+       pulse = !pulse;
+       return;
+   }
+   
+   cpu = 0;
+   Freq = Platform_getCpuFreq(this, cpu);
+   if (Freq > 1000) {
+       Freq /= 1000;
+   }
+   if (Freq > 1000) {
+       ghz = Freq / 1000;
+       mhz = Freq % 1000;
+       roundup = ((mhz % 10) > 5);
+       mhz /= 10;
+       mhz += roundup;
+       xSnprintf(buffer, len, "%d.%02d GHz", ghz, mhz);
+   } else {
+       xSnprintf(buffer, len, "%4d MHz", Freq);
+   }
+   pulse = !pulse;
+}
+
+MeterClass CpuFreqMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = CpuFreqMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 1,
+   .total = 100.0,
+   .attributes = CpuFreqMeter_attributes,
+   .name = "CpuFreq",
+   .uiName = "CpuFreq",
+   .caption = "Cpu Freq: ",
+};
+
diff --git a/CpuTempMeter.c b/CpuTempMeter.c
new file mode 100644
index 0000000..4052256
--- /dev/null
+++ b/CpuTempMeter.c
@@ -0,0 +1,39 @@
+/*
+htop - CpuTempMeter.c
+(C) 2020 @lex
+*/
+
+#include "CpuTempMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+int CpuTempMeter_attributes[] = {
+   CPU_TEMP
+};
+
+static void CpuTempMeter_setValues(Meter* this, char* buffer, int len) {
+   int Temp = Platform_getCpuTemp(this);
+   if (Temp > 1000) {
+       Temp /= 1000;
+   }
+   xSnprintf(buffer, len, "%4d C", Temp);
+}
+
+MeterClass CpuTempMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = CpuTempMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 1,
+   .total = 100.0,
+   .attributes = CpuTempMeter_attributes,
+   .name = "CpuTemp",
+   .uiName = "CpuTemp",
+   .caption = "Cpu Temp: "
+};
diff --git a/CpuVcoreMeter.c b/CpuVcoreMeter.c
new file mode 100644
index 0000000..03adb6d
--- /dev/null
+++ b/CpuVcoreMeter.c
@@ -0,0 +1,84 @@
+/*
+htop - CpuVcoreMeter.c
+(C) 2020 Alexander Finger
+*/
+
+#include "CpuVcoreMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int CpuVcoreMeter_attributes[] = {
+   CPU_VCORE
+};
+
+static void CpuVcoreMeter_setValues(Meter* this, char* buffer, int len) {
+   int v1,v2;
+   int Vcore, Vcore_l, Vcore_b;
+   char buf1[80], buf2[80];
+   int h;
+   
+   if (Platform_getCpuBigLITTLE()) {
+       h = len / 2;
+       if (h > 79)
+           h = 79;
+       Vcore_b = Platform_getCpuVcore_b(this);
+       if (Vcore_b > 1000) {
+           Vcore_b /= 1000;
+       }
+       if (Vcore_b >= 1000) {
+           Vcore_b /= 10;
+           v1 = Vcore_b / 100;
+           v2 = Vcore_b % 100;
+           xSnprintf(buf1, h, "%d.%02d V ", v1, v2);
+       } else {
+           xSnprintf(buf1, h, "%4d mV", Vcore_b);
+       }
+       Vcore_l = Platform_getCpuVcore_l(this);
+       if (Vcore_l > 1000) {
+           Vcore_l /= 1000;
+       }
+       if (Vcore_l >= 1000) {
+           Vcore_l /= 10;
+           v1 = Vcore_l / 100;
+           v2 = Vcore_l % 100;
+           xSnprintf(buf2, h, "%d.%02d V ", v1, v2);
+       } else {
+           xSnprintf(buf2, h, "%4d mV", Vcore_l);
+       }
+       xSnprintf(buffer, len, "%s  %s  (big.LITTLE)", buf1, buf2);
+       return;
+   }
+   
+   Vcore = Platform_getCpuVcore(this);
+   if (Vcore > 1000) {
+       Vcore /= 1000;
+   }
+   if (Vcore >= 1000) {
+       Vcore /= 10;
+       v1 = Vcore / 100;
+       v2 = Vcore % 100;
+       xSnprintf(buffer, len, "%d.%02d V", v1, v2);
+   } else {
+       xSnprintf(buffer, len, "%4d mV", Vcore);
+   }
+}
+
+MeterClass CpuVcoreMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = CpuVcoreMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 1,
+   .total = 100.0,
+   .attributes = CpuVcoreMeter_attributes,
+   .name = "CpuVcore",
+   .uiName = "CpuVcore",
+   .caption = "Cpu Vcor: "
+};
diff --git a/Eth0_Meter.c b/Eth0_Meter.c
new file mode 100644
index 0000000..90e512a
--- /dev/null
+++ b/Eth0_Meter.c
@@ -0,0 +1,60 @@
+/*
+htop - Eth0_Meter.c
+(C) 2018 @lex
+*/
+
+#include "Eth0_Meter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int Eth0_Meter_attributes[] = {
+   ETH0_INTERFACE
+};
+
+static void Eth0_Meter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    static char szIP[48];
+    static unsigned int use_cached = 0;
+    Settings* settings = this->pl->settings;
+    
+    if ((use_cached++ % 2)) {
+        xSnprintf(buffer, len, "%s", szIP);
+        return;
+    }
+    
+    if (settings->eth0_alias[0] != 0) {
+        ret = findIP_interface(settings->eth0_alias, szIP, sizeof(szIP));
+    } else {
+        ret = findIP_interface("eth0", szIP, sizeof(szIP));
+    }
+    
+    if (ret) {
+        xSnprintf(buffer, len, "%s", szIP);
+    } else {
+        xSnprintf(buffer, len, "%s", "down");
+    }
+}
+
+MeterClass Eth0_Meter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = Eth0_Meter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = Eth0_Meter_attributes,
+   .name = "Eth0",
+   .uiName = "Eth0 IP",
+   .caption = "Eth0 IP: ",
+};
+
+
diff --git a/Eth0_StatsMeter.c b/Eth0_StatsMeter.c
new file mode 100644
index 0000000..974c656
--- /dev/null
+++ b/Eth0_StatsMeter.c
@@ -0,0 +1,83 @@
+/*
+htop - Eth0_StatsMeter.c
+(C) 2020 @lex
+*/
+
+#include "Eth0_StatsMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int Eth0_StatsMeter_attributes[] = {
+   ETH0_INTERFACE
+};
+
+/* borrowed from slurm */
+static void Eth0_StatsMeter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    float rxspeed;
+    float txspeed;
+    Settings* settings = this->pl->settings;
+    double refreshdelay;
+    static double old = 0.;
+    static double now = 0.;
+    static int flash = 0;
+
+    now = get_wall_time();
+    refreshdelay = now - old;
+    if (old == 0.)
+       refreshdelay = 1.;
+    old = now;
+
+    if (settings->eth0_alias[0] != 0) {
+        ret = Platform_getEth_stats(settings->eth0_alias, 0, 0);
+    } else {
+        ret = Platform_getEth_stats("eth0", 0, 0);
+    }
+    
+    if (ret) {
+        if (Platform_Eth0_stats.rx_bytes_comp > Platform_Eth0_stats.rx_bytes)
+            Platform_Eth0_stats.rx_bytes_comp = 0;
+        if (Platform_Eth0_stats.tx_bytes_comp > Platform_Eth0_stats.tx_bytes)
+            Platform_Eth0_stats.tx_bytes_comp = 0;
+
+        /* we assume here the refresdelay is 1 sec which sometimes is 1.5, so we have a peak */ 
+        rxspeed = (Platform_Eth0_stats.rx_bytes - Platform_Eth0_stats.rx_bytes_comp) / refreshdelay;
+        txspeed = (Platform_Eth0_stats.tx_bytes - Platform_Eth0_stats.tx_bytes_comp) / refreshdelay;
+
+        xSnprintf(buffer, len, "%.2f KB/s - %.2f KB/s (TX/RX)", (float) txspeed / 1024, (float) rxspeed / 1024);
+
+        Platform_Eth0_stats.rx_bytes_comp = Platform_Eth0_stats.rx_bytes;
+        Platform_Eth0_stats.tx_bytes_comp = Platform_Eth0_stats.tx_bytes;
+
+    } else {
+        if (!(flash % 2))
+            xSnprintf(buffer, len, "%s", "unavail");
+        else
+            xSnprintf(buffer, len, "%s", "");
+        flash++;
+    }
+}
+
+MeterClass Eth0_StatsMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = Eth0_StatsMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = Eth0_StatsMeter_attributes,
+   .name = "Eth0stat",
+   .uiName = "Eth0 stat",
+   .caption = "Eth0 stat: ",
+};
+
+
diff --git a/Eth1_Meter.c b/Eth1_Meter.c
new file mode 100644
index 0000000..41cfa05
--- /dev/null
+++ b/Eth1_Meter.c
@@ -0,0 +1,60 @@
+/*
+htop - Eth1_Meter.c
+(C) 2018 @lex
+*/
+
+#include "Eth1_Meter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int Eth1_Meter_attributes[] = {
+   ETH1_INTERFACE
+};
+
+static void Eth1_Meter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    static char szIP[48];
+    static unsigned int use_cached = 0;
+    Settings* settings = this->pl->settings;
+    
+    if ((use_cached++ % 2)) {
+        xSnprintf(buffer, len, "%s", szIP);
+        return;
+    }
+    
+    if (settings->eth1_alias[0] != 0) {
+        ret = findIP_interface(settings->eth1_alias, szIP, sizeof(szIP));
+    } else {
+        ret = findIP_interface("eth1", szIP, sizeof(szIP));
+    }
+    
+    if (ret) {
+        xSnprintf(buffer, len, "%s", szIP);
+    } else {
+        xSnprintf(buffer, len, "%s", "down");
+    }
+}
+
+MeterClass Eth1_Meter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = Eth1_Meter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = Eth1_Meter_attributes,
+   .name = "Eth1",
+   .uiName = "Eth1 IP",
+   .caption = "Eth1 IP: ",
+};
+
+
diff --git a/Eth1_StatsMeter.c b/Eth1_StatsMeter.c
new file mode 100644
index 0000000..85e6dc9
--- /dev/null
+++ b/Eth1_StatsMeter.c
@@ -0,0 +1,83 @@
+/*
+htop - Eth1_StatsMeter.c
+(C) 2020 @lex
+*/
+
+#include "Eth1_StatsMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int Eth1_StatsMeter_attributes[] = {
+   ETH1_INTERFACE
+};
+
+/* borrowed from slurm */
+static void Eth1_StatsMeter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    float rxspeed;
+    float txspeed;
+    Settings* settings = this->pl->settings;
+    double refreshdelay;
+    static double old = 0.;
+    static double now = 0.;
+    static int flash = 0;
+
+    now = get_wall_time();
+    refreshdelay = now - old;
+    if (old == 0.)
+       refreshdelay = 1.;
+    old = now;    
+
+    if (settings->eth1_alias[0] != 0) {
+        ret = Platform_getEth_stats(settings->eth1_alias, 1, 0);
+    } else {
+        ret = Platform_getEth_stats("eth1", 1, 0);
+    }
+    
+    if (ret) {
+        if (Platform_Eth1_stats.rx_bytes_comp > Platform_Eth1_stats.rx_bytes)
+            Platform_Eth1_stats.rx_bytes_comp = 0;
+        if (Platform_Eth1_stats.tx_bytes_comp > Platform_Eth1_stats.tx_bytes)
+            Platform_Eth1_stats.tx_bytes_comp = 0;
+
+        /* we assume here the refresdelay is 1 sec which sometimes is 1.5, so we have a peak */ 
+        rxspeed = (Platform_Eth1_stats.rx_bytes - Platform_Eth1_stats.rx_bytes_comp) / refreshdelay;
+        txspeed = (Platform_Eth1_stats.tx_bytes - Platform_Eth1_stats.tx_bytes_comp) / refreshdelay;
+
+        xSnprintf(buffer, len, "%.2f KB/s - %.2f KB/s (TX/RX)", (float) txspeed / 1024, (float) rxspeed / 1024);
+
+        Platform_Eth1_stats.rx_bytes_comp = Platform_Eth1_stats.rx_bytes;
+        Platform_Eth1_stats.tx_bytes_comp = Platform_Eth1_stats.tx_bytes;
+
+    } else {
+        if (!(flash % 2))
+            xSnprintf(buffer, len, "%s", "unavail");
+        else
+            xSnprintf(buffer, len, "%s", "");
+        flash++;
+    }
+}
+
+MeterClass Eth1_StatsMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = Eth1_StatsMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = Eth1_StatsMeter_attributes,
+   .name = "Eth1stat",
+   .uiName = "Eth1 stat",
+   .caption = "Eth1 stat: ",
+};
+
+
diff --git a/GpuTempMeter.c b/GpuTempMeter.c
new file mode 100644
index 0000000..92394b3
--- /dev/null
+++ b/GpuTempMeter.c
@@ -0,0 +1,39 @@
+/*
+htop - GpuTempMeter.c
+(C) 2018 @lex
+*/
+
+#include "GpuTempMeter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+int GpuTempMeter_attributes[] = {
+   GPU_TEMP
+};
+
+static void GpuTempMeter_setValues(Meter* this, char* buffer, int len) {
+   int Temp = Platform_getGpuTemp(this);
+   if (Temp > 1000) {
+       Temp /= 1000;
+   }
+   xSnprintf(buffer, len, "%4d C", Temp);
+}
+
+MeterClass GpuTempMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = GpuTempMeter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 1,
+   .total = 100.0,
+   .attributes = GpuTempMeter_attributes,
+   .name = "GpuTemp",
+   .uiName = "GpuTemp",
+   .caption = "Gpu Temp: "
+};
diff --git a/Kernel_Meter.c b/Kernel_Meter.c
new file mode 100644
index 0000000..45c675f
--- /dev/null
+++ b/Kernel_Meter.c
@@ -0,0 +1,55 @@
+/*
+htop - Kernelversion_Meter.c
+(C) 2018 @lex
+*/
+
+#include "Kernel_Meter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int Kernelversion_Meter_attributes[] = {
+   KERNEL_VERSION
+};
+
+static void Kernelversion_Meter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    static char version[256];
+    static int use_cached = 0;
+    
+    if ((use_cached++ % 10)) {
+        xSnprintf(buffer, len, "%s", version);
+        return;
+    }
+    
+    ret = ReadTokenValue( "/proc/version", "Linux version", version);
+    
+    if (ret) {
+        xSnprintf(buffer, len, "%s", version);
+    } else {
+        xSnprintf(buffer, len, "%s", "down");
+    }
+}
+
+MeterClass Kernelversion_Meter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = Kernelversion_Meter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = Kernelversion_Meter_attributes,
+   .name = "Kernelversion",
+   .uiName = "Kernel version",
+   .caption = "Kernel: ",
+};
+
+
diff --git a/Makefile.am b/Makefile.am
index cd5209c..6557c6a 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -21,7 +21,9 @@ ClockMeter.c ColorsPanel.c ColumnsPanel.c CPUMeter.c CRT.c MainPanel.c \
 DisplayOptionsPanel.c FunctionBar.c Hashtable.c Header.c htop.c ListItem.c \
 LoadAverageMeter.c MemoryMeter.c Meter.c MetersPanel.c Object.c Panel.c \
 BatteryMeter.c Process.c ProcessList.c RichString.c ScreenManager.c Settings.c \
-SignalsPanel.c StringUtils.c SwapMeter.c TasksMeter.c UptimeMeter.c \
+SignalsPanel.c StringUtils.c SwapMeter.c TasksMeter.c UptimeMeter.c CpuFreqMeter.c CpuTempMeter.c GpuTempMeter.c CpuVcoreMeter.c \
+interfaces.c OS_Meter.c	Eth0_Meter.c Eth1_Meter.c Wlan0_Meter.c Wlan1_Meter.c Kernel_Meter.c OrangePi_Meter.c \
+Wlan0_StatsMeter.c Eth0_StatsMeter.c Eth1_StatsMeter.c BlockDevice_ioStatsMeter.c \
 TraceScreen.c UsersTable.c Vector.c AvailableColumnsPanel.c AffinityPanel.c \
 HostnameMeter.c OpenFilesScreen.c Affinity.c IncSet.c Action.c EnvScreen.c \
 InfoScreen.c XAlloc.c
@@ -32,7 +34,9 @@ CPUMeter.h CRT.h MainPanel.h DisplayOptionsPanel.h FunctionBar.h \
 Hashtable.h Header.h htop.h ListItem.h LoadAverageMeter.h MemoryMeter.h \
 BatteryMeter.h Meter.h MetersPanel.h Object.h Panel.h ProcessList.h RichString.h \
 ScreenManager.h Settings.h SignalsPanel.h StringUtils.h SwapMeter.h \
-TasksMeter.h UptimeMeter.h TraceScreen.h UsersTable.h Vector.h Process.h \
+TasksMeter.h UptimeMeter.h CpuFreqMeter.h CpuTempMeter.h GpuTempMeter.h CpuVcoreMeter.h TraceScreen.h UsersTable.h Vector.h Process.h \
+interfaces.h OS_Meter.h	Eth0_Meter.h Eth1_Meter.h Wlan0_Meter.h Wlan1_Meter.h Kernel_Meter.h OrangePi_Meter.h \
+Wlan0_StatsMeter.h Eth0_StatsMeter.h Eth1_StatsMeter.h BlockDevice_ioStatsMeter.h \
 AffinityPanel.h HostnameMeter.h OpenFilesScreen.h Affinity.h IncSet.h Action.h \
 EnvScreen.h InfoScreen.h XAlloc.h
 
diff --git a/OS_Meter.c b/OS_Meter.c
new file mode 100644
index 0000000..588c234
--- /dev/null
+++ b/OS_Meter.c
@@ -0,0 +1,55 @@
+/*
+htop - OSversion_Meter.c
+(C) 2018 @lex
+*/
+
+#include "OS_Meter.h"
+#include "Platform.h"
+#include "CRT.h"
+
+#include "interfaces.h"
+
+/*{
+#include "Meter.h"
+}*/
+
+
+int OSversion_Meter_attributes[] = {
+   OS_VERSION
+};
+
+static void OSversion_Meter_setValues(Meter* this, char* buffer, int len) {
+    int ret;
+    static char version[256];
+    static int use_cached = 0;
+    
+    if ((use_cached++ % 10)) {
+        xSnprintf(buffer, len, "%s", version);
+        return;
+    }
+    
+    ret = ReadKeyValue( "/etc/os-release", "PRETTY_NAME=", version);
+    
+    if (ret) {
+        xSnprintf(buffer, len, "%s", version);
+    } else {
+        xSnprintf(buffer, len, "%s", "down");
+    }
+}
+
+MeterClass OSversion_Meter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = OSversion_Meter_setValues, 
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 8,
+   .total = 100.0,
+   .attributes = OSversion_Meter_attributes,
+   .name = "OSversion",
+   .uiName = "OS version",
+   .caption = "OS vers: ",
+};
+
+
diff --git a/Process.c b/Process.c
index 471f529..9ac5fa6 100644
--- a/Process.c
+++ b/Process.c
@@ -1,6 +1,7 @@
 /*
 htop - Process.c
 (C) 2004-2015 Hisham H. Muhammad
+(C) 2020 Alexander Finger
 Released under the GNU GPL, see the COPYING file
 in the source distribution for its full text.
 */
diff --git a/Process.h b/Process.h
index f702ca0..fbd9ef5 100644
--- a/Process.h
+++ b/Process.h
@@ -5,6 +5,7 @@
 /*
 htop - Process.h
 (C) 2004-2015 Hisham H. Muhammad
+(C) 2020 Alexander Finger
 Released under the GNU GPL, see the COPYING file
 in the source distribution for its full text.
 */
diff --git a/ProcessList.c b/ProcessList.c
index 7482b03..4ef1e83 100644
--- a/ProcessList.c
+++ b/ProcessList.c
@@ -69,6 +69,7 @@ typedef struct ProcessList_ {
    unsigned long long int freeSwap;
 
    int cpuCount;
+   int cpuBigLITTLE;
 
 } ProcessList;
 
diff --git a/ProcessList.h b/ProcessList.h
index 572d484..aa0e6c0 100644
--- a/ProcessList.h
+++ b/ProcessList.h
@@ -63,6 +63,7 @@ typedef struct ProcessList_ {
    unsigned long long int freeSwap;
 
    int cpuCount;
+   int cpuBigLITTLE;
 
 } ProcessList;
 
diff --git a/ScreenManager.c b/ScreenManager.c
index 05e1c02..3ae6670 100644
--- a/ScreenManager.c
+++ b/ScreenManager.c
@@ -130,6 +130,7 @@ static void checkRecalculation(ScreenManager* this, double* oldTime, int* sortTi
    if (newTime < *oldTime) *rescan = true; // clock was adjusted?
    if (*rescan) {
       *oldTime = newTime;
+      Header_draw(this->header);
       ProcessList_scan(pl);
       if (*sortTimeout == 0 || this->settings->treeView) {
          ProcessList_sort(pl);
@@ -139,7 +140,7 @@ static void checkRecalculation(ScreenManager* this, double* oldTime, int* sortTi
    }
    if (*redraw) {
       ProcessList_rebuildPanel(pl);
-      Header_draw(this->header);
+      // Header_draw(this->header);
    }
    *rescan = false;
 }
diff --git a/Settings.c b/Settings.c
index db2fa06..912ad7d 100644
--- a/Settings.c
+++ b/Settings.c
@@ -59,6 +59,28 @@ typedef struct Settings_ {
    bool accountGuestInCPUMeter;
    bool headerMargin;
 
+   char CpuFreq_handler[256]; 
+   char CpuTemp_handler[256]; 
+   char CpuVCore_l_handler[256];
+   char CpuVCore_b_handler[256];
+   
+   char GpuVCore_handler[256];
+   char GpuTemp_handler[256];
+   
+   char BoardName[128];
+   char KernelVersionFull[256];
+   char KernelVersionShort[64];
+   
+   char IP_wlan0[32];
+   char IP_wlan1[32];
+   char IP_eth0[32];
+   char IP_eth1[32];
+   
+   char eth0_alias[32];
+   char eth1_alias[32];
+   char wlan0_alias[32];
+   char wlan1_alias[32];
+
    bool changed;
 } Settings;
 
@@ -141,6 +163,12 @@ static void Settings_defaultMeters(Settings* this) {
    this->columns[1].modes[r++] = TEXT_METERMODE;
    this->columns[1].names[r] = xStrdup("Uptime");
    this->columns[1].modes[r++] = TEXT_METERMODE;
+   
+   this->columns[1].names[r] = xStrdup("CpuTemp");
+   this->columns[1].modes[r++] = TEXT_METERMODE;
+   this->columns[1].names[r] = xStrdup("CpuFreq");
+   this->columns[1].modes[r++] = TEXT_METERMODE;
+
 }
 
 static void readFields(ProcessField* fields, int* flags, const char* line) {
@@ -244,7 +272,41 @@ static bool Settings_read(Settings* this, const char* fileName) {
       } else if (String_eq(option[0], "right_meter_modes")) {
          Settings_readMeterModes(this, option[1], 1);
          didReadMeters = true;
-      }
+      } else if (String_eq(option[0], "BoardName")) {
+         strcpy(this->BoardName,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "CpuFreq_handler")) {
+         strcpy(this->CpuFreq_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "CpuTemp_handler")) {
+         strcpy(this->CpuTemp_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "CpuVCore_l_handler")) {
+         strcpy(this->CpuVCore_l_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "CpuVCore_b_handler")) {
+         strcpy(this->CpuVCore_b_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "GpuVCore_handler")) {
+         strcpy(this->GpuVCore_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "GpuTemp_handler")) {
+         strcpy(this->GpuTemp_handler,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "eth0_alias")) {
+         strcpy(this->eth0_alias,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "eth1_alias")) {
+         strcpy(this->eth1_alias,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "wlan0_alias")) {
+         strcpy(this->wlan0_alias,option[1]);
+         didReadMeters = true;
+      } else if (String_eq(option[0], "wlan1_alias")) {
+         strcpy(this->wlan1_alias,option[1]);
+         didReadMeters = true;
+      }  
+
       String_freeArray(option);
    }
    fclose(fd);
@@ -320,6 +382,23 @@ bool Settings_write(Settings* this) {
    fprintf(fd, "left_meter_modes="); writeMeterModes(this, fd, 0);
    fprintf(fd, "right_meters="); writeMeters(this, fd, 1);
    fprintf(fd, "right_meter_modes="); writeMeterModes(this, fd, 1);
+   
+   fprintf(fd, "# SBC hardware and Kernel specific path.\n");
+   fprintf(fd, "# Editable manually.\n");
+   fprintf(fd, "BoardName=%s\n", this->BoardName);
+   fprintf(fd, "CpuFreq_handler=%s\n", this->CpuFreq_handler);
+   fprintf(fd, "CpuTemp_handler=%s\n", this->CpuTemp_handler);
+   fprintf(fd, "CpuVCore_l_handler=%s\n", this->CpuVCore_l_handler); 
+   fprintf(fd, "CpuVCore_b_handler=%s\n", this->CpuVCore_b_handler);    
+   fprintf(fd, "GpuVCore_handler=%s\n", this->GpuVCore_handler); 
+   fprintf(fd, "GpuTemp_handler=%s\n", this->GpuTemp_handler); 
+   
+   fprintf(fd, "# Wlan / Eth alias\n");
+   fprintf(fd, "eth0_alias=%s\n",this->eth0_alias);
+   fprintf(fd, "eth1_alias=%s\n",this->eth1_alias);
+   fprintf(fd, "wlan0_alias=%s\n",this->wlan0_alias);
+   fprintf(fd, "wlan1_alias=%s\n",this->wlan1_alias);
+
    fclose(fd);
    return true;
 }
